#--------------------- importa librerie -----------------------
from tkinter import *
from functools import partial
import pyads
#----------------------costanti
#--- dei pulsanti
testoled = "0 volt"
beckled = "grey"
#--------------------- fine costanti -----------------------

chan = [False, False, False, False, False, False, False, False]
ConnPlc = pyads.Connection('192.168.1.10.1.1 ',851)

class Mask():
      def chiudi(win2): #chiude il programma
         GestPLC.sconnetti()
         win2.destroy()
      def nomebottone(num,ledx): # se premuto un bottone cambia lo stato del canale 
         if chan[num]:
            chan[num] = False
            ledx['text'] = "0 volt"
            ledx.config(bg="grey") 
         else:
             chan[num] = True
             ledx['text'] = "24 volt"
             ledx.config(bg="green")
         MAINchan = 'MAIN.chan'+ str(num + 1)
         GestPLC.scrivi(MAINchan,chan[num])
      def maschera(window,foto): #crea la maschera
      #column
         rigaled = [1,1,2,2,3,3,4,4]
         rigabottoni =  [5,5,6,6,10,10,14,14]
         colonna=[0,21,0,21,0,21,0,21]
         for numero in range(0,8):
             if chan[numero]:
                testoled = "24 volt"
                beckled = "green"
             else:
                testoled = "0 volt"
                beckled = "grey"
             led = "led" + str(numero+1)
             led =Label(window, text=testoled,background = beckled,fg = "white")
             led.grid(column=colonna[numero],row=rigaled[numero])
             pulsante = "chan" + str(numero+1)
             nomepulsante = "chan" + str(numero)
             pulsante  = Button(window, text = "chan"+ str(numero+1), bg = "dark slate gray", fg = "white",
                                   width = 8, 
                                   padx = "2m", 
                                   pady = "1m",command=partial(Mask.nomebottone,numero,led) )
             pulsante.grid(column=colonna[numero],row=rigabottoni[numero])

         #column 1
             canvas = Canvas(window,
                   width= foto.width(),
                   height= foto.height(),
                   border=1,
                   relief="sunken",
                   highlightthickness=0)
             canvas.grid(column=1,row=0,columnspan=10,rowspan=20)
             canvas.pack_propagate(0)
             image1 =  canvas.create_image(
                  0,
                  0,
                  image= foto,
                  anchor="nw")


             chiudi = Button(window, text = "chiudi", background = "red", #crea il bottone chiudi
                                  width = 8, 
                                  padx = "2m", 
                                  pady = "1m", command=partial(Mask.chiudi,window))
             chiudi.grid(column=1,row=21)

class GestPLC(): #classe che gestisce la connessione al plc
   def connetti():
      try:
         # si connette al  PLC
         #plc = pyads.Connection('192.168.1.10.1.1 ',851)
         # apriamo la connessione
         ConnPlc.open()
         # vediamo se la connessione funziona
         ConnPlc.read_device_info()
         return True
      except:
        return False
   def leggi():
       # leggo i valori dei canali nel plc e riempio una lista
       for numero in range(1,9):
             MAINchan = 'MAIN.chan'+ str(numero)
             chan[numero - 1] = ConnPlc.read_by_name(str(MAINchan),pyads.PLCTYPE_BOOL)
   def scrivi(mainc,chanx):
       ConnPlc.write_by_name(mainc,chanx ,pyads.PLCTYPE_BOOL )
   def sconnetti():
       ConnPlc.close()
         
if GestPLC.connetti():
   GestPLC.leggi()
   win = Tk()
   photo1 = PhotoImage(file="El2008.gif")
   win.title("El2008")
   Mask.maschera(win,photo1)
  # win.mainloop()
else:
   print(" PLC Beckhoff CX5020 non è acceso o non è stato inizializzato")

